/*
 * C header file to determine compile machine byte order. Take care when
 * cross compiling. (!)

 * $Id: byteorder.h,v 1.2 2008/08/27 07:40:44 joern Exp joern $
 */


#if !defined(BYTEORDER_INCLUDED)

#if defined(__linux)
  #include <endian.h>
#else
  #include <sys/param.h>
#endif

#if defined(BYTE_ORDER)
  #if (BYTE_ORDER == BIG_ENDIAN)
    #define MACHINE_IS_BIG_ENDIAN
  #elif (BYTE_ORDER == LITTLE_ENDIAN)
    #define MACHINE_IS_LITTLE_ENDIAN
  #endif
#endif /*BYTE_ORDER*/

#if !defined(MACHINE_IS_BIG_ENDIAN) && !defined(MACHINE_IS_LITTLE_ENDIAN)
  #if defined(_BIG_ENDIAN) || defined(_MIPSEB)
    #define MACHINE_IS_BIG_ENDIAN
  #endif
  #if defined(_LITTLE_ENDIAN) || defined(_MIPSEL)
    #define MACHINE_IS_LITTLE_ENDIAN
  #endif
#endif /*!MACHINE_IS_BIG_ENDIAN && !MACHINE_IS_LITTLE_ENDIAN*/

/* bail out if no byte sex constant is defined at this point */
#if !defined(MACHINE_IS_BIG_ENDIAN) && !defined(MACHINE_IS_LITTLE_ENDIAN)
#error
#endif

#define BYTEORDER_INCLUDED

#define swap32(u) ((u>>24)|(u<<24)|(u>>8&0xff00)|(u<<8&0xff0000))
#endif /*BYTEORDER_INCLUDED*/
